#version 330 compatibility
#extension GL_EXT_geometry_shader4: enable
#extension GL_EXT_gpu_shader4: enable

layout(triangles) in;
layout(triangle_strip, max_vertices=6) out;

uniform float uTime;

out vec4 vertex_color;

void main()
{
  vec3 V01, V02;  
  vec4 N;
  int i;
  
  V01 = ( gl_in[1].gl_Position - gl_in[0].gl_Position ).xyz;
  V02 = ( gl_in[2].gl_Position - gl_in[0].gl_Position ).xyz;
  N =  vec4( normalize( cross( V01, V02 )), 0.0  );  
  
  for(i=0; i<3; i++)
  {
    gl_Position = uModelViewProjectionMatrix * gl_in[i].gl_Position;
    vertex_color = vec4(0.0, 0.0, 1.0, 1.0);
    EmitVertex();
  }
  EndPrimitive();
  
  for(i=0; i<3; i++)
  {
    gl_Position = uModelViewProjectionMatrix * (gl_in[i].gl_Position + N * uTime);
    vertex_color = vec4(1.0, 0.0, 0.0, 0.6);
    EmitVertex();
  }
  EndPrimitive();
}
